算法每日一题 Day05|双指针解决盛最多水的容器问题

盛最多水的容器(附链接)

https://leetcode.cn/problems/container-with-most-water/

一、题目描述


二、思路

  • 核心思想是什么?
    利用双指针来进行计算
  • 为什么这么做?
    暴力解法的时间复杂度为O(n^2),时间超时,通过规律,单调性,体积V= 高度h宽度w

    按照示例:数组为 int\[\] height = {1,8,6,2,5,4,8,3,7};
    第一次计算:v = 1
    (8-0) = 8;
    第二次计算:v= 1*(7-0) = 7;
    第三次计算:v= 1*(6-0) = 6;
    通过以上计算,发现向内枚举的时候,高度不变,宽度在变小,整体的体积也是在减少,所以在高度不变的时候,宽度最大的,体积最大。
    所以我们想到利用双指针来解决这道题,定义两个指针,left指针指向数组的第一个数,right指针指向数组的最后一个数,第一次计算出体积v,然后移动指针(比较heightleft 和 heightright中的值,如果left指向的值更小,left++,如果right指向的值更小,right--)

三、关键点

  • 能找到单调性来做这道题

四、代码(Java )

java 复制代码
class Solution {
    public int maxArea(int[] height) {
        int left = 0;
        int right = height.length - 1;
        int ret = 0;
        while (left < right) {
            //先计算出第一次的体积
            int v = Math.min(height[left], height[right]) * (right - left);
            //更新体积的最大值
            ret = Math.max(v, ret);
            if (height[left] < height[right])
                left++;
            else
                right--;
        }
        return ret;
    }

}

五、总结

面积 = 高度(两指针中较小值)× 宽度(指针间距)。

若移动较长的指针,高度不会增加(因为高度由短板决定),宽度减少,面积必然减小 → 浪费计算。

因此每次都移动较短的指针,才有可能让高度变大,从而在宽度减少的情况下依然获得更大面积。

相关推荐
ZhengEnCi3 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
秋天的怀念_David4 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Pniubi4 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
hhb_6184 小时前
大模型落地三重优化实战
人工智能·算法·机器学习
云和数据.ChenGuang4 小时前
光哥说Python RAG 系统需要哪些评估指标:从检索到生成的全链路评测指南
网络·人工智能·python·算法·langchain
2601_970703836 小时前
工业除湿机租赁:把一份租金合同拆开看
大数据·数据结构·算法·数据库架构·推荐算法
心中有你02146 小时前
Java实现Dijkstra最短路径算法(邻接表 + 优先队列)
java·数据库·算法
ZhengEnCi7 小时前
同样的模型,为什么本地和云 API 差别那么大:量化精度、聊天模板与采样参数的三大元凶
人工智能·算法·llm
Flynn Liang7 小时前
RAG 答非所问/幻觉怎么破?Spring AI QuestionAnswerAdvisor 召回优化实战(TopK/重排/混合检索)
人工智能·算法·spring·rag·幻觉·springai
liminla!7 小时前
SQL 从入门到进阶:语法速查与实战练习(完整优化版)
数据库·sql·算法